ifile --- C version

ifilter code written by Diego Zamboni <zamboni@cs.purdue.edu>  March 8th, 1997
   some changes made by Jason Rennie <jr6b@cs.cmu.edu>  April 13-14, 1997
irefile code written by Jason Rennie <jr6b@cs.cmu.edu>  March 30-31, 1997
                                                        April 10-14, 1997

This is more of a log on the C code and is not intended as part of the required
reading to install ifile.  Read on if you wish.

Comments on ifilter by Diego
----------------------------
This program emulates the behavior of ifilter, a program in perl for 
filtering incoming email into MH folders based on a database stored in
~/.idata.

This program is a complete translation of the Perl version, but with some
optimizations made to make it considerably faster.

Believe it or not, most of the speed improvement comes not from the fact
that it is written in C, but from some other optimizations I made in the
algorithm for processing the messages.

However, the fact that it is in C helps a lot in terms of the memory
footprint, which is much smaller.

I haven't done any serious benchmarking, but the perl version ordinarily
took around 17-19 seconds to file a new message, and this program takes
between 2-4 seconds to do the same.

To compile, just "make". I haven't made any provisions for compatibility
yet, so this should compile and run cleanly on Solaris (which is where I
wrote it), but I can't make guarantees on other systems. However, most of
the C is pretty standard. The most tricky part could be the rcvstore
routine, which does forks and dups and things like that, but I have tried
to stick to standard function calls, so even this should not be much of
a problem.

One other function that I know is not present in all versions of Unix and
which may cause problems is strdup. But then, it is easy to implement if
needed, so that shouldn't be a problem.

Enjoy.

--Diego Zamboni (zamboni@cs.purdue.edu)

Comments on irefile by Jason
----------------------------
The code is a very straight port from the perl code.  Some of the code is
taken from Diego's port of ifilter.c.

Jason Rennie <jr6b@cs.cmu.edu>

Plans for the future/notes about current code:

- require that all paths have '/' appended to them
- modularize reading/writing of the database
- create a struct for .mh_profile & related info (including paths of stuff)
- centralize location of global paths in ifile.h
- create classes for assoc arrays and extendable arrays, including functions
  for getting size/no. of elements in extendable arrays (using var.elems as
  a parameter to EXT_ARRAY_* can cause serious trouble in your code)

